#include <cstdio>
#include <cstring>
#include <vector>
#include <algorithm>
using namespace std;

// #define INF 0x3f3f3f3f

#define MAXN 1000100
#define INF (1<<30)
#define LSB(x) ((x)^(x-1)&(x))

int N, aib[2*MAXN], res;
vector<int> Poz[MAXN];

void update(int x, int val)
{
	for(; x < 2*N; x += LSB(x))
		aib[x] = min(aib[x], val);
}

int query(int x)
{
	int ret = INF;
	for(; x > 0; x -= LSB(x))
		ret = min(ret, aib[x]);
	return ret;
}

void clear(int x)
{
	for(; x < 2*N; x += LSB(x))
		aib[x] = INF;
}

void solve(void)
{
	int i, j, k, q, last, prev, val, add, val2;
	res = 2;
	// memset(aib, INF, sizeof(aib));
	for(i = 1; i < 2*N; i++)
		aib[i] = INF;
	for(i = 1; i <= N; i++)
	{
		for(j = 0; j < Poz[i].size(); j++)
		{
			val = (j+1)-(Poz[i][j]-(j+1));
			k = query(val+N);
			if(k != INF)
			{
				if(k == 0) 
					prev = 1;
				else 
					prev = Poz[i][k-1]+1;
				if(j == Poz[i].size()-1)
					last = N;
				else
					last = Poz[i][j+1]-1;
				val2 = (k+1)-1-(Poz[i][k]-(k+1));
				add = Poz[i][k]-prev+(last-Poz[i][j]);
				res = max(res, Poz[i][j]-Poz[i][k]+1+min(add, val-val2)); 
			}
			update(val-1+N, j);
		}
		for(j = 0; j < Poz[i].size(); j++)
		{
			val = (j+1)-(Poz[i][j]-(j+1));
			clear(val-1+N);
		}
	}
}

void read_data(void)
{
	int i, j, k, x;
	scanf("%d ", &N);
	for(i = 1; i <= N; i++)
		scanf("%d" , &x), Poz[x].push_back(i);
}

void write_data(void)
{
	printf("%d\n", res);
}

int main(void)
{
	freopen("mate.in", "rt", stdin);
	freopen("mate.out", "wt", stdout);

	read_data();
	solve();
	write_data();

	return 0;
}









