#include <iostream>
#include <fstream>
#include <cassert>
#include <vector>
#include <algorithm>
using namespace std;

const char iname[] = "mate.in";
const char oname[] = "mate.out";

const int MAX_N  = 500005;
const int MAX_AI = 1 << 22;

int S[MAX_N], n;

vector <int> T[MAX_N];

int Ai[MAX_AI], s[MAX_N];


#define left(n)   ((n) * 2)
#define right(n)  (left(n) + 1)

void read_in(void)
{
    ifstream in(iname);
    assert( in >> n );

    for (int i = 1; i <= n; ++ i)
    {
        assert( in >> S[i] );
        assert( 1 <= S[i] && S[i] <= n );
    }
    for (int i = 1; i <= n; ++ i)
        T[i].push_back(0);
    for (int i = 1; i <= n; ++ i)
        T[ S[i] ].push_back(i);
    for (int i = 1; i <= n; ++ i)
        T[i].push_back(n + 1);
    in.close();
}

void _update(int n, int lo, int hi)
{
    int mid = lo + (hi - lo) / 2;

    Ai[n] = MAX_N;
    if (hi == lo)  return ;
    _update(left(n), lo, mid);
    _update(right(n), mid + 1, hi);
}

void update(int n, int lo, int hi, int p, int val)
{
    int mid = lo + (hi - lo) / 2;

    if (hi == lo) {
        if (val == MAX_N)
            Ai[n] = MAX_N;
        else
            Ai[n] = min(Ai[n], val);
        return ;
    }
    if (p <= mid)
        update(left(n), lo, mid, p, val);
    else
        update(right(n), mid + 1, hi, p, val);
    Ai[n] = min( Ai[ left(n) ], Ai[ right(n) ] );
}

int query(int n, int lo, int hi, int a, int b)
{
    int mid = lo + (hi - lo) / 2;

    if (a <= lo && hi <= b)
        return Ai[n];
    int l = (a <= mid) ? query(left(n), lo, mid, a, b) : MAX_N;
    int r = (mid < b)  ? query(right(n), mid + 1, hi, a, b) : MAX_N;
    return min(l, r);
}

int main(void)
{
    read_in();

    int res = 1;

    _update(1, -n, +n);

    for (int i = 1; i <= n; ++ i) if (T[i].size() - 2 >= 1)
    {
        s[0] = 0;

        for (int j = 1; j <= (int)T[i].size() - 2; ++ j)
        {
            s[j] = s[j - 1] + 1;
            s[j] -= (T[i][j] - T[i][j - 1] - 1);
        }

        for (int j = 1; j <= (int)T[i].size() - 2; ++ j)
        {
            update(1, -n, +n, s[j], j);

            if (s[j] >= 0)
            {
                int t_res = T[i][j];
                int t = min(s[j], T[i][j + 1] - T[i][j] - 1);
                res = max(res, t_res + t);
            }
            else {
                int l = query(1, -n, +n, -n, s[j] + 1);
                int r = j;
                int t_res = T[i][r] - T[i][l] + 1;
                int diff = s[r] - s[l] + 1;

                int t;
                t = min(diff, T[i][l] - T[i][l - 1] - 1);
                t_res += t, diff -= t;
                t = min(diff, T[i][r + 1] - T[i][r] - 1);
                t_res += t, diff -= t;
                res = max(res, t_res);
            }
        }

        for (int j = 1; j <= (int)T[i].size() - 2; ++ j)
            update(1, -n, +n, s[j], MAX_N);
    }

    ofstream(oname) << res << "\n";

    return 0;
}
