/*
Autor: Victor Rusu
Punctaj: 100
*/
#include <cstdio>
#include <algorithm>
#include <cassert>

using namespace std;

#define FIN "trotuar.in"
#define FOUT "trotuar.out"

#define MAX_N 100015
#define MAX_L 768
#define MOD 666013
#define LL long long

int N, L, K, M;
int sol;
int H[MAX_L];
int X[MAX_L], Y[MAX_L];
int pos[MAX_L];
int C[MAX_N], CL;

void read() {
    scanf("%d %d %d %d", &N, &L, &K, &M);
    for (int i = 1; i <= K; ++i) {
        scanf("%d", &H[i]);
    }
    for (int i = 1; i <= M; ++i)
        scanf("%d %d", &X[i], &Y[i]);
}

void mod(int &a) {
    if (a >= MOD)
        a -= MOD;
    if (a >= MOD)
        a %= MOD;
    if (a < 0)
        a += MOD;
}

int putere(int x, int p) {
    if (p == 0) return 1;
    if (p & 1)
        return ((LL)x * putere(x, p - 1)) % MOD;
    else {
        int tmp = putere(x, p / 2);
        return ((LL)tmp * tmp) % MOD;
    }
}

void knapsack() {
    C[0] = 1;
    for (int i = 1; i <= L; ++i)
        for (int j = 1; j <= K; ++j)
            if (i >= H[j]) {
                C[i] += C[i - H[j]];
                mod(C[i]);
            }
    CL = C[L];
    for (int i = 1; i <= K; ++i)
        if (H[i] == L) {
            --CL;
            break;
        }
    mod(CL);
    C[L] = 0;
    for (int i = L; i <= N; ++i) {
        for (int j = 1; j <= K; ++j) {
            C[i] += C[i - H[j]];
            mod(C[i]);
        }
        C[i] += ((LL)CL * C[i - L]) % MOD;
        mod(C[i]);
    }
}

void creste(int p, int dist) {
    int ind1, ind2;
    ind1 = ind2 = p;
    while (ind1 > 1 && pos[ind1 - 1] == pos[p]) --ind1;
    while (ind2 < L && pos[ind2 + 1] == pos[p]) ++ind2;

    if (ind1 > 1 || ind2 < L)
        sol = ((LL)sol * putere(C[ind2 - ind1 + 1], dist / L)) % MOD;
    else
        sol = ((LL)sol * C[dist]) % MOD;

    for (int i = ind1; i <= ind2; ++i)
        pos[i] += dist;
}

void solve() {
    int gata = 0;
    knapsack();

    for (int i = 1; i <= L; ++i) {
        ++M;
        X[M] = N + 1;
        Y[M] = i;
    }

    sol = 1;
    while (!gata) {
        int p = -1, dist = N + 1;
        
        int lo = N + 1, hi = -1;
        for (int i = 1; i <= L; ++i) {
            if (pos[i] < lo) lo = pos[i];
            if (pos[i] > hi) hi = pos[i];
        }
        if (hi - lo < L) lo = N + 1;
 
        for (int i = 1; i <= L; ++i)
            if (pos[i] <= lo) {
                int tmp = N + 1;
                for (int j = 1; j <= M; ++j)
                    if (i == Y[j] && X[j] > pos[i]) {
                        tmp = min(tmp, X[j] - pos[i] - 1);
                    }
                if (dist > tmp) {
                    p = i;
                    dist = tmp;
                }
            }

        if (lo <= N) {
            if (dist == 0)
                ++pos[p];
            else
                creste(p, min(dist, ((hi - lo) / L) * L));
        } else {
            creste(p, dist);
            ++pos[p];
        }

        gata = 1;
        for (int i = 1; i <= L; ++i)
            if (pos[i] <= N) {
                gata = 0;
                break;
            }
    }
    
    printf("%d\n", sol);
}

int main() {
    freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);

    read();
    solve();

    return 0;
}
